import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 *
 * GroupDriver
 *
 * Driver/Tester of Group type
 *
 */

public class GroupDriver {

	public static void main(String[] args) {
		GroupDriver driver = new GroupDriver();
		driver.sample1();
	}

	//-------------------------------------------
	//Samples

	/**
	 * The list actually contains objects of class "StudentClub"
	 * and "Team". However, StudentClub and Team are also "Group"
	 * types, and that's the type we care about here.
	 */
	private void sample1() {
		List<Group> list = this.diverseList();
		for (Group next: list) {
			prn("Title: " + next.title());
			prn("Size: " + next.size());
			prn("-----------------------");
		}
	}

	//-------------------------------------------
	//Helpers

	/** Returns list containing objects of different classes */
	private List<Group> diverseList() {
		List<Group> list = new ArrayList<>();
		list.add(new Team("Wow Team", Arrays.asList("Kofi", "Asha", "Bruce")));
		list.add(new StudentClub("Math Club", Arrays.asList("Asha", "Chen", "Mo", "Zo")));
		return list;
	}

	public static void prn(Object o) {
		System.out.println(o.toString());
	}



}