import java.awt.Color;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 *
 * ShippableDriver
 *
 * Driver/Tester of Shippable type
 *
 */

public class ShippableDriver {

	public static void main(String[] args) {
		ShippableDriver driver = new ShippableDriver();
		driver.sample1();
	}

	//-------------------------------------------
	//Samples

	/**
	 * The list actually contains objects of class "Shirt"
	 * and "Book". However, Shirt and Book are also "Shippable"
	 * types, and that's the type we care about here.
	 */
	private void sample1() {
		List<Shippable> list = this.diverseList();
		double sum = 0;
		for (Shippable nextElement: list) {
			sum += nextElement.shippingWeightAsPounds();
			prn("Shipping Weight: " + nextElement.shippingWeightAsPounds() + " pounds");
			prn("-----------------------");
		}
		prn("Total shipping weight: " + sum + " pounds");
	}

	//-------------------------------------------
	//Helpers

	/** Returns list containing objects of different classes */
	private List<Shippable> diverseList() {
		List<Shippable> list = new ArrayList<>();
		list.add(new Book("A Tale of Two Cities", 0.75));
		list.add(new Shirt(Color.red, 0.3));
		list.add(new Book("The Alchemist", 0.5));
		return list;
	}

	public static void prn(Object o) {
		System.out.println(o.toString());
	}



}