import java.util.ArrayList;
import java.util.List;

/**
 *
 * SummaryObjectDriver
 *
 * Driver/Tester of SummaryObject type
 *
 */

public class SummaryObjectDriver {

	public static void main(String[] args) {
		SummaryObjectDriver driver = new SummaryObjectDriver();
		driver.sample1();
	}

	//-------------------------------------------
	//Samples

	/**
	 * The list actually contains objects of class "Shirt"
	 * and "Book". However, Shirt and Book are also "Shippable"
	 * types, and that's the type we care about here.
	 */
	private void sample1() {
		List<SummaryObject> list = this.diverseList();
		for (SummaryObject nextElement: list) {
			prn("Summary: " + nextElement.toSummary());
		}
	}

	//-------------------------------------------
	//Helpers

	/** Returns list containing objects of different classes */
	private List<SummaryObject> diverseList() {
		List<SummaryObject> list = new ArrayList<>();
		list.add(new Room(205));
		list.add(new Student("Asha"));
		list.add(new Room(211));
		list.add(new Student("Kofi"));
		return list;
	}

	public static void prn(Object o) {
		System.out.println(o.toString());
	}



}