import java.util.ArrayList;
import java.util.List;

/**
 *
 * TouristAttractionDriver
 *
 * Driver/Tester of TouristAttraction type
 *
 */

public class TouristAttractionDriver {

	public static void main(String[] args) {
		TouristAttractionDriver driver = new TouristAttractionDriver();
		driver.sample1();
	}

	//-------------------------------------------
	//Samples

	/**
	 * The list actually contains objects of class "Lake" and "Park"
	 * However, Lake and Park are also "TouristAttraction" types,
	 * and that's the type we care about here
	 */
	private void sample1() {
		List<TouristAttraction> list = this.diverseList();
		for (TouristAttraction next: list) {
			prn("Label: " + next.label());
			prn("Description: " + next.description());
			prn("-----------------------");
		}
	}

	//-------------------------------------------
	//Helpers

	/** Returns list containing objects of different classes */
	private List<TouristAttraction> diverseList() {
		List<TouristAttraction> list = new ArrayList<>();
		list.add(new Lake("Mud Lake", "Good carp fishing"));
		list.add(new Park("Itasca State Park", "Mississippi River Headwaters"));
		list.add(new Lake("Clear Lake", "Best swimming"));
		return list;
	}

	public static void prn(Object o) {
		System.out.println(o.toString());
	}



}